/* JQ Xhr function */
function fetch(link, dataSend) {
    httpRequest = new XMLHttpRequest();
    return $.ajax({
        'method': 'GET',
        'type': 'GET',
        'url': link,
        'dataType': 'json',
        'data': dataSend
    });
}

/* Native Xhr function */
function makeRequest(method, url) {
    var promise = new Promise(function (resolve, reject) {
        var xhr = new XMLHttpRequest();
        xhr.open(method, url);
        xhr.onload = function () {
            if (this.status >= 200 && this.status < 300) {
                resolve(xhr.response);
            } else {
                reject({ status: this.status, statusText: xhr.statusText });
            }
        };
        xhr.onerror = function () {
            reject({ status: this.status, statusText: xhr.statusText });
        };
        xhr.send();
    });
    return promise;
}

class Log extends React.Component {

    constructor(props) {
        super(props);
    }

    render() {
        const data = this.props.lists;
        return (
            <div data-type="log">
                {
                    data.map((e, i) => {
                        return (
                            <span key={e.product_id}>
                                Product => {e.product_id}
                            </span>
                        )
                    })
                }
            </div>
        )
    }
}

/* Class Textinput */
class Textinput extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            value: "Edit me for first time.",
            stat: 0
        };
        this.onChange = this.onChange.bind(this);
        this.onBlur = this.onBlur.bind(this);
    }

    onReset() {
        this.setState({ stat: 0 });
        this.setState({ value: '' });
        localStorage.removeItem('Textinput-state');
        localStorage.removeItem('Textinput-state-text');
    }

    componentDidMount() {
        if (localStorage.getItem('Textinput-state') !== null && localStorage.getItem('Textinput-state') > 0) {
            this.setState({ stat: localStorage.getItem('Textinput-state') });
        }
        if (localStorage.getItem('Textinput-state-text') !== null) {
            this.setState({ value: JSON.parse(localStorage.getItem('Textinput-state-text')) });
        }
    }

    onChange(event) {
        this.setState({ value: event.target.value });
        this.setState((prevState, props) => ({
            stat: parseInt(prevState.stat) + 1
        }));
        /* Update To LocalStorage */
        console.log("Updating number..");
        console.log("Updating Text..");
        localStorage.setItem('Textinput-state', parseInt(this.state.stat));
        localStorage.setItem('Textinput-state-text', JSON.stringify(this.state.value));
    }

    onBlur(event) {
        /* finish or something? */
        console.log("onBlur: Trigger!");
        if (event.target.value === '') {
            this.onReset();
        }
    }

    render() {
        return (
            <div>
                <hr />
                <input type="text" value={this.state.value} onChange={this.onChange} onBlur={this.onBlur} data-log="test" />
                <hr />
                Text Value: {this.state.value}<br />
                Keypress: {this.state.stat}
            </div>
        )
    }
}

/* Slick Class */
class Slickslider extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            status: false,
            lists: [],
            stat: localStorage.getItem('Textinput-state') || 0
        };
    }
    componentWillMount() {
        console.log("Hello there, slider is coming");
    }

    componentDidMount() {
        makeRequest('GET', 'https://bombbike.getappeasy.com/store/api/v1/product/lists?cur_page=1&per_page=10&txt_sortby=&txt_filter_json=&txt_screen_json=&_=1484305569766', {}).then((res) => {
            /* update */
            var e = JSON.parse(res);
            this.setState({ status: e.ok });
            this.setState({ lists: e.data.dataList });
        });
    }

    _componentChild(a) {
        const _test = function () {
            return (
                <div>test</div>
            )
        }

        if (a === 'test') {
            return _test()
        }
    }

    renderItems(src, i) {
        return (
            <div key={i.toString()} className="itemsImage">
                <img src={src} style={{ margin: '0 auto', width: 'auto', height: '500px' }} />
            </div>
        )
    };

    render() {

        const settings = {
            dots: true,
            centerMode: true
        };

        return (
            <div>
                <div className='container'>
                    <div>Current Status: {this.state.status.toString()}</div>
                    <Log text="LogLogLog" lists={this.state.lists} />
                    {this.state.lists.length > 0 && this.state.status &&
                        <Slider {...settings}>
                            {
                                this.state.lists.map((e, i) => {
                                    return (this.renderItems(e.product_image[0].image_url, e.product_image[0].image_id))
                                })
                            }
                        </Slider>
                    }
                </div>
                <Textinput value={this.state.value} />
                {this._componentChild('test')}
            </div>
        )
    }
}

ReactDOM.render(
    <Slickslider />,
    document.getElementById('root')
);